import time
import sys
from os import system, name
from pynput import keyboard

# clears screen
def clear():
    """
    clears sceen
    :return: None
    """
    system('cls' if name == 'nt' else 'clear')


class EventHandler(object):
    """
    Event Handler

    Shows animation while waiting for user response. Must be implemented in 3 parts.

    # Object creation
    ev = EventHandler()

    # Plays animation
    ev.wait_for_user()

    # Captures the keypress from the user
    player_input = ev.key_pressed

    """

    def __init__(self):
        self.key_was_pressed = False
        self.key_pressed = ''

    def on_press(self, key):
        self.key_was_pressed = True
        self.key_pressed = key

    def wait_for_user(self):
        self.key_was_pressed = False
        animation = "|/―\\"
        listener = keyboard.Listener(on_press=self.on_press)
        listener.start()
        while True:
            for i in range(8):
                time.sleep(0.2)
                sys.stdout.write("\r" + animation[i % len(animation)])
                sys.stdout.flush()
                if self.key_was_pressed:
                    self.key_pressed = str(self.key_pressed).strip("\'")
                    break
            if self.key_was_pressed:
                self.key_pressed = str(self.key_pressed).strip("\'")
                clear()
                break


# Object creation
ev = EventHandler()

def menu_generator(options, exec):
    """
    :param options: the text that is displayed when the menu is generated (ex. 1. Inspect Horse)
    :param exec: the method that is ran when the option is selected
    :return: None
    """

    print("\nPlease select an option:")
    execute_options = exec

    for i, a in enumerate(options):
        print(i+1, ":", a)

    # Plays animation
    ev.wait_for_user()

    # Captures the keypress from the user
    player_input = ev.key_pressed
    print("\n\n", player_input)
    try:
        player_input = int(player_input)-1
    except ValueError:
        print("Please select a valid option")
    clear()
    # Executes the method in the chosen index of exec

    execute_options[player_input]()
    return player_input


def player_menu():
    """
    - Inventory management todo
        - Inspect equipment todo
        - List inventory
    - Equip items
    - Cast out-of-combat spells
    - Use items todo
    - Read Notes todo
    - Check quest markers todo
    - Check stats
    - Save todo
    - Load todo
    - Level up
    - Probably more
    :return:
    """






